function Jnumrange(A,J,m)
global definite
clc;
%disp('');disp('');disp('');disp('');
%disp('Programmer: Bebiano et al.');
%disp(' Department of Mathematics');
%disp(' Coimbra University');
%disp(' Coimbra, PORTUGAL');
%disp(' e-mail: bebiano@mat.uc.pt');
%disp(' ');
%disp(' December 2007')
%disp(' This file is named as Jnumrange.m');
%disp('1. run matlab');
%disp('2. input this file Jnumrange and all the routines necessaries that');
%disp('2. can be found on http://www.mat-uc.pt/~bebiano');
%disp(' ')
%disp(' This program produces the boundary of the J-numerical range of a ');
%disp('complex matrix by using MATLAB package, where J is a Hermitian 
%disp('involutive matrix that defines the indefinite inner product');
%disp('of the same size of A and diferent from I and -I where I is the ');
%disp('identity matrix');
%disp('You need to enter a complex matrix A, a Hermitian involutive complex '); 
%disp('matrix J of the same size of A and diferent from I and -I where I
%disp('is the identity matrix and a positive integer number m');
%disp('eg. A=[2+3*i 2; 0 -2+3*i] enter, J=[1 0; 0 -1] enter, m=30 enter ');
%disp(' ');
%disp(' ****** Press any key to run the program ******');
%pause;

%%

Tol=10^(-5); 
i=sqrt(-1);

m=15;

m=round(m);
if m<10  
    m=10; 
end 


%%
B=J*A;definite=0;
if isequal(B, B(1,1)*eye(size(J,2)))==1
   plot(real(B(1,1)),imag(B(1,1)),'.blue', 'MarkerSize',5)         
   title('Since the matrix is J-scalar, W_J(A) is a singleton')
   return;
elseif isequal(J,eye(size(J,2))) || isequal(J,-eye(size(J,2)))
    definite=1;
end
[X1_round,X2_round,degenerate1,degenerate2]=boundary_curve(A,J,m,Tol);
if definite==1
    [X1_round_dif]=diferent_elements(X1_round,Tol);
    if size(X1_round_dif,2)>1
       [col]=collinear(X1_round_dif,X2_round,Tol);
       if col ==1
           plot(real(X1_round),imag(X1_round),'color','red','linewidth',1.25);
       else
           Ind=convhull(real(X1_round_dif),imag(X1_round_dif));
           plot(real(X1_round_dif(Ind)),imag(X1_round_dif(Ind)),'color','red','linewidth',1.25);
       end
       title('Classical Numerical Range');
       xlabel('Real Axis');
       ylabel('Imaginary Axis');
    end
else
    if degenerate1==0
        if degenerate2==1
            step_5(A,J,Tol);
        else
            pseudo_convexhull(X1_round,X2_round,Tol);
        end 
    end
end
if definite==1 || (degenerate1==0 && degenerate2==0) 
    Z=eig(A); %% Plot the eigenvalues of the matrix A
    Z_linha=[];
        for r=1:size(Z,1)
            Z_linha=[Z_linha Z(r,1)];
        end
    [Z_round]=rounding(Z_linha); %Remove the rounding errors of Z 
    plot(real(Z_round),imag(Z_round),'+black', 'MarkerSize',5);
    hold on;
   %axis([-8 8 -6 6])
    axis equal
    
end
  
