function [X1_round,X2_round,degenerate1,degenerate2]=boundary_curve(A,J,m,Tol)
global definite

% Checking the existence of some kind of errors
%%
if ~isequal(size(J,1),size(J,2)) 
    error('J must be a square matrix');
end
if ~isequal(size(A,1),size(A,2))
    error('A must be a square matrix');
end
if ~isequal(size(J),size(A))
    error('A and J must have the same size');
end
for r=1:size(J,2)
    for s=1:size(J,2)
        if r~=s && J(r,s)~=0 || J(r,r)~=1 && J(r,r)~=-1
            error('J must be an Hermitian involutive matrix');
        end
    end
end


% Plots the boundary generating points, if there exists at least one
% directions with the eigenvalues all real, non interlating and with 
% anisotropic eigenvectors 
%%
X1_round=[];X2_round=[];
[degenerate1,direc,eig_real]=directions(A,J,m,Tol);
degenerate2=0;
if degenerate1~=1
    row1=1; row2=1; X1=[]; X2=[]; vec=[]; 
    for t=1:size(direc,2)
        D1=[]; D2=[];
        w=direc(t);
        T=(exp(pi*i*(w-1)/(2*m))*A+ exp(-pi*i*(w-1)/(2*m))*J*A'*J)/2;
        [U,D]=eig(T);
        for s=1:size(U,2)
            u=U(:,s);
            if abs(real(u'*J*u))>=Tol %no null J-norm
                z2=real(u'*J*A*u)/real(u'*J*u);
                z3=imag(u'*J*A*u)/real(u'*J*u);
                if real(u'*J*u)>0 %positive J-norm
                    X1(row1)=z2+i*z3;
                    row1=row1+1;
                    D1=[D1 D(s,s)];
                else
                    X2(row2)=z2+i*z3;
                    row2=row2+1;
                    D2=[D2 D(s,s)];
                end
            end
        end

        for r=1:size(eig_real,2)
            if eig_real(r)==w
               [interla]=interlating(D1,D2);
               vec=[vec interla];
            end
        end
    end
    %Cheking if there exist at leats one direction with noninterlacing eigenvalues
    aux=0;
    for t=1:size(vec,2)
        if vec(t)==2 %It means that in the direction w=eig_real(t) the eigenvalues noninterlace.  
            aux=1; 
            break;
        end
    end
    if aux==1 || definite==1 %This is not a degenerate case, so it plots the boundary generating points
        
        if definite==0
            [X1_round]=rounding(X1); %Remove the rounding errors of X1
            [X2_round]=rounding(X2); %Remove the rounding errors of X2
        elseif definite==1 && isequal(J,eye(size(J,2)))
            [X1_round]=rounding(X1); %Remove the rounding errors of X1
            X2_round=[]; 
        elseif definite==1 && isequal(J,-eye(size(J,2)))
            X2_round=[]; 
            [X1_round]=rounding(X2); %Remove the rounding errors of X1
            
        end
        plot(real(X1_round),imag(X1_round),'.b',real(X2_round),imag(X2_round),'.r','MarkerSize',9); %Plots the boundary generating points
        hold on;
    else
        degenerate2=1; %Degenerate case. Follows to step_5
        return;
    end
end





