function hull(q1,X1,X2,Tol)

% This routine plots the pseudoconvex hull of the elements of the matrix q1 that defines one of the two 
% pseudo-line segments of X1 (or of X2)

%Convex hull of the elements of the matriz q1  
Ind=convhull(real(q1),imag(q1));

%Checking if the elements that defines the convex hull of q1 are elements of 
%X1 or of X2
v=q1(Ind);
Ind1=[];pos1=[];
    for r=1:size(q1(Ind),1)
        for s=1:size(X2,2)
            if v(r,1)==X2(1,s) 
                Ind1=[Ind1 Ind(r,1)];
                pos1=[pos1 r];
            end                
        end
        for s=1:size(X1,2)
            if v(r,1)==X1(1,s)
                Ind1=[Ind1 Ind(r,1)];
                pos1=[pos1 r];
            end                
        end
    end

    
%Remove the repeated elements of Ind1             
Ind1_dif=Ind1(1);
    pos1_dif=pos1(1);
    aux1=0;
    for r=1:size(Ind1,2)
        s=r+1;
            if s<=size(Ind1,2)
                for t=1:r
                    if abs(Ind1(t)-Ind1(s))<Tol % If the elements Ind1(t) and Ind1(s) are equal or aproximately equal 
                        aux1=1;
                        break
                    else
                        aux1=0;
                    end
                end
                if aux1==0
                    Ind1_dif=[Ind1_dif Ind1(s)];
                    pos1_dif=[pos1_dif pos1(s)];
                end
           end
    end   
   
%Checking if the elements of X1 (or X2) that lies on the convex hull of q1
%are consecutives
aux2=0;
    for t=1:size(pos1_dif,2)-1
        if abs(pos1_dif(1,t)-pos1_dif(1,t+1))==1  
            aux2=0;
        else
            aux2=1;
            break
        end
    end
 

    if aux2==0 
        if pos1_dif(1,1)~=1
            Ind2=[Ind(pos1_dif(1,1)-1,1) Ind1_dif Ind(pos1_dif(1,size(pos1_dif,2))+1,1)];
            plot(real(q1(Ind2)),imag(q1(Ind2)),'color','black','linewidth',1.25)
            xlabel('Real Axis')
            ylabel('Imaginary Axis')
            title('J-Numerical Range')
        else
            Ind2=[Ind(size(Ind,1)-1,1) Ind1_dif Ind(pos1_dif(1,size(pos1_dif,2))+1,1)];
            plot(real(q1(Ind2)),imag(q1(Ind2)),'color','black','linewidth',1.25) 
            xlabel('Real Axis')
            ylabel('Imaginary Axis')
            title('J-Numerical Range')                            
        end

    else
        Y1=[];
            for t=1:size(pos1_dif,2)-1
                if abs(pos1_dif(1,t)-pos1_dif(1,t+1))==1  
                    Y1=[Y1 Ind(pos1_dif(1,t))];
                else
                    r=t+1;
                    Y1=[Y1 Ind(pos1_dif(1,t))];
                    break
                end
            end

        Y2=[];
             for s=r:size(pos1_dif,2)
                Y2=[Y2 Ind(pos1_dif(1,s))];
             end
        Y2=[Y2 Ind(pos1_dif(1,1))];
        Ind2=[Y1 Ind(size(Y1,2)+1,1)];
        Ind3=[Ind(size(Ind,1)-size(Y2,2),1) Y2];
        plot(real(q1(Ind2)),imag(q1(Ind2)),'color','black','linewidth',1.25)
        hold on
        plot(real(q1(Ind3)),imag(q1(Ind3)),'color','black','linewidth',1.25)
        xlabel('Real Axis')
        ylabel('Imaginary Axis')
        title('J-Numerical Range')
    end    

    
